Status: Resolved Priority: Should have
Author: Peter Niederlag Category:
Created: 2014-01-10 Assigned To: Peter Niederlag
Updated: 2014-04-12 Due date:
TYPO3 Version: 6.2
PHP Version:
Complexity:
Is Regression: No
Sprint Focus:
Subject: TemplateService runs processIncludes twice when TypoScript is not in cache
Description

TYPO3\CMS\Core\TypoScript\TemplateService

->processIncludes() is run "mandatory" from the stack ->start() ->runThroughTemplates() and doing all the work that needs to be
done.

However if there is no entry in the caching framework for the parsed (transformed into array) TypoScript then ->processIncludes() is
run a second time from within ->generateConfig(). The TypoScript does not change (exept one extra LF added into each Template
with an <INCLUDE_TYPOSCRIPT instruction). There is no reason to call processIncludes() a second time.

How to check/reproduce

    -  See the difference in lineNumbers in TypoScript-Object-Browser and Template-Analyzer in BE. You get 1 line offset per template
that has an INCLUDE_TYPOSCRIPT instruction.

    -  Put a debug statement inside of processIncludes() and check the frontend in cached / non-cached states and see that it is run
twice after the cache has been cleared in BE. If you compare substr_count($value, LF); before and after checkIncludeLines() is called
inside processIncludes() you will find: On first run INCLUDE_TYPOSCRIPT is executed and line numbers are different, which makes
perfect sense. When the TS is not found in the cache and  processIncludes() is executed the second time for some very weird reason
line numbers are +1 if the template has an INCLUDE_TYPOSCRIPT (that was already processed). The TypoScript itself is exactly the
same, except for this extra empty line, which won't be part of the hash-calculation and gone again on the next page-cycle (when the
TS is found in cache).

Related issues:
related to Core - Bug # 54897: Wrong lineNumbers and templateNames in TypoScr... Resolved 2014-01-10

Associated revisions
Revision cbbc7853 - 2014-04-12 01:30 - Peter Niederlag 

[BUGFIX] Don't run processIncludes more than once

processIncludes() is run "mandatory" from the stack >start()
>runThroughTemplates() and doing all the work that needs to be done.

Resolves: #54903
Releases: 6.2
Change-Id: Id2be1a25aa23a05849297315c74358a9ef4ff9bb
Reviewed-on: https://review.typo3.org/26748
Reviewed-by: Alexander Opitz
Tested-by: Alexander Opitz
Reviewed-by: Oliver Klee
Reviewed-by: Markus Klein
Tested-by: Markus Klein
History
#1 - 2014-01-10 18:50 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26748

#2 - 2014-01-10 19:33 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26748

#3 - 2014-01-14 21:22 - Gerrit Code Review

Patch set 3 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26748

#4 - 2014-01-14 21:31 - Gerrit Code Review

Patch set 4 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26748

#5 - 2014-01-14 21:35 - Gerrit Code Review

Patch set 5 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26748

#6 - 2014-02-25 12:21 - Gerrit Code Review

Patch set 6 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26748

#7 - 2014-02-25 13:05 - Gerrit Code Review

Patch set 7 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26748

#8 - 2014-02-25 13:18 - Gerrit Code Review

Patch set 8 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26748

#9 - 2014-03-26 23:30 - Gerrit Code Review
Patch set 9 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26748

#10 - 2014-03-26 23:34 - Gerrit Code Review

Patch set 10 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26748

#11 - 2014-04-12 02:30 - Anonymous
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:cbbc78539932566f469d8e7f1ec0fb72181347a3.
